#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>

static void sigintP()
{
	printf("pid=%d\n", getpid());
	signal(SIGINT, sigintP);
}

static void sigalrm()
{
	exit(1);
}

static void sigintF()
{
	signal(SIGINT, SIG_IGN);
	signal(SIGALRM, sigalrm);
	alarm(5);
}

static void sigchld()
{
	int status;
	wait(&status);
	exit(0);
}

int main(void)
{
	signal(SIGCHLD, sigchld);
	if (fork() == 0) {
		signal(SIGINT, sigintF);
		while (1) {
			printf("ici fils\n");
			sleep(1);
		}
	}
	while (1) {
		signal(SIGINT, sigintP);
		printf("ici pere\n");
		sleep(1);
	}
}
